<template>

    <div>

    </div>
<!--    <div class="home">-->
<!--        <ErrorComponent :error-value="error" class="w"/>-->
<!--        <SuccessComponent :success-value="success" class="w"/>-->

<!--        <div class="actions">-->
<!--            <div>-->

<!--                <label>-->
<!--                    <input v-model="floorName" placeholder="Floor Name">-->
<!--                </label>-->
<!--            </div>-->
<!--            <div>-->
<!--                <label>-->
<!--                    <select v-model="timeZone">-->
<!--                        <option disabled selected>Select TimeZone</option>-->
<!--                        <option v-for="t in timeZones" :value="t">{{t}}</option>-->
<!--                    </select>-->
<!--                </label>-->
<!--            </div>-->
<!--            <div class="button" @click="CreateFloor">Create</div>-->
<!--        </div>-->
<!--        <div class="floors">-->
<!--            <div v-for="(f,i) in floors" class="fh">-->
<!--                <div class="flex clickable" @click="Toggle(i)">-->
<!--                    <div class="name">{{f.name}}</div>-->
<!--                    <div class="tz">{{f.timeZone}}</div>-->
<!--                    <router-link class="button" :to="`/floor/${f.id}`">View</router-link>-->
<!--                    <router-link class="button" :to="`/floor/${f.id}/floorplan/create`">Add FloorPlan</router-link>-->
<!--                </div>-->
<!--                <FloorPlans v-if="toggle[i]" :floor="f.id"/>-->
<!--            </div>-->
<!--        </div>-->

<!--    </div>-->
</template>


<style lang='scss' scoped>

    <!--$w: 800px;-->

    <!--.w {-->
    <!--    box-sizing: border-box;-->
    <!--    width: $w;-->
    <!--    margin: auto;-->
    <!--}-->

    <!--.actions {-->
    <!--    display: flex;-->
    <!--    justify-content: space-between;-->
    <!--    width: $w;-->
    <!--    box-sizing: border-box;-->
    <!--    margin: 20px auto;-->

    <!--    input {-->
    <!--        width: 350px;-->
    <!--    }-->

    <!--    input, select {-->
    <!--        padding: 10px 20px;-->
    <!--        box-sizing: border-box;-->
    <!--        height: 40px;-->
    <!--    }-->
    <!--}-->

    <!--.button {-->
    <!--    &:hover {-->
    <!--        background: #00000022;-->
    <!--    }-->

    <!--    text-decoration: none;-->
    <!--    color: black;-->
    <!--    border: 1px solid black;-->
    <!--    padding: 10px 20px;-->
    <!--}-->

    <!--.clickable {-->
    <!--    cursor: pointer;-->
    <!--}-->

    <!--.floors {-->
    <!--    width: 90%;-->
    <!--    max-width: $w;-->
    <!--    margin: auto;-->

    <!--    .fh {-->
    <!--        border: 1px solid black;-->
    <!--    }-->

    <!--    .flex {-->
    <!--        padding: 20px;-->
    <!--        display: flex;-->
    <!--        justify-content: space-between;-->
    <!--    }-->
    <!--}-->

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {FloorFlyWeightResponse} from "../../../classLibrary/core/floorFlyWeightResponse";
    import {coreApi} from "../init";
    import ErrorComponent from "../components/ErrorComponent.vue";
    import FloorPlans from "../components/FloorPlans.vue";
    import SuccessComponent from "../components/SuccessComponent.vue";
    import {FloorResponse} from "../../../classLibrary/core/floorResponse";

    const props = {};

    const Base = Vue.extend({props});

    @Component({
        components: {SuccessComponent, FloorPlans, ErrorComponent},
        props
    })
    export default class FloorHome extends Base {
        floors: FloorFlyWeightResponse[] = [];
        toggle: boolean[] = [];
        error = "";
        success = "";
        timeZones: string[] = [];

        floorName: string = "";
        timeZone: string = "";

        Toggle(i: any) {
            Vue.set(this.toggle, i, !this.toggle[i]);
        }

        async updateFloor() {
            const fr = await coreApi.Get<FloorFlyWeightResponse[]>("Floor");
            if (fr.success) {
                this.floors = fr.Ok!;
                const diff =  this.floors.length - this.toggle.length;
                for(let i =0; i< diff; i++){
                    this.toggle.push(false);
                }
            } else {
                this.err = fr.error!;
            }
        }

        async created() {

            const tzr = await coreApi.Get<string[]>("timezones");
            const fr = await coreApi.Get<FloorFlyWeightResponse[]>("Floor");
            const r = tzr.BindDeep(x => fr.Bind(y => [x, y] as [string[], FloorFlyWeightResponse[]]));

            if (r.success) {
                const [tz, f] = r.Ok!;
                this.floors = f!;
                this.timeZones = tz;
                this.toggle = this.floors.Map(x => false);
            } else {
                this.err = r.error ?? "unknown error";
            }
        }


        private get err():string{
            return this.error;
        }
        private get ok():string{
            return this.success
        }

        private set err(i: string) {
            this.error = i;
            this.success = "";
        }

        private set ok(i: string) {
            this.error = "";
            this.success = i;
        }

        async CreateFloor() {

            if (this.floorName == "" || this.floorName == null) {
                this.err = "Please enter floor name";
                return;
            }
            if (this.timeZone == "" || this.timeZone == null) {
                this.err = "Please enter TimeZone";
                return;
            }

            const ar = await coreApi.Post<FloorResponse>("Floor", {
                name: this.floorName,
                timeZone: this.timeZone
            });

            if (ar.success) {
                this.ok = `Create floor ${ar.Ok!.info.name}`;
            } else {
                this.err = ar.error!;
            }
            await this.updateFloor();
        }
    }
</script>
